=== debian/control ===
Source: orthanc-wsi
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-all-dev,
               libcurl4-openssl-dev | libcurl4-dev,
               libdcmtk-dev,
               libjpeg-dev,
               libjsoncpp-dev,
               libopenjp2-7-dev,
               libpng-dev,
               libtiff5-dev,
               orthanc-dev (>= 1.1.0),
               uuid-dev,
               yui-compressor,
               zlib1g-dev
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/orthanc-wsi.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/orthanc-wsi.git
Homepage: http://www.orthanc-server.com/static.php?page=wsi

Package: orthanc-wsi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: orthanc (>= 1.1.0),
            libopenslide0
Description: Whole-slide imaging support for Orthanc (digital pathology)
 Orthanc-WSI brings support of whole-slide imaging for digital
 pathology into Orthanc, the lightweight, RESTful Vendor Neutral
 Archive for medical imaging.
 .
 This package contains two command-line tools to convert whole-slide
 images to and from DICOM. Support for proprietary file formats is
 available through OpenSlide. The package also contains an Orthanc
 plugin to display such DICOM images by any standard Web browser. The
 implementation follows DICOM Supplement 145.
