=== debian/changelog ===
orthanc-wsi (0.4+dfsg-4build1) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 08:39:30 +0000

orthanc-wsi (0.4+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with libopenjp2-7-dev 2.2.0-1, Closes: #876807

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 04 Oct 2017 10:53:04 +0200

orthanc-wsi (0.4+dfsg-3) unstable; urgency=medium

  * Team upload
  * Update search path for dicomdict, Closes: #873024

 -- Gert Wollny <gewo@debian.org>  Wed, 23 Aug 2017 20:55:25 +0000

orthanc-wsi (0.4+dfsg-2) unstable; urgency=medium

  [Gert Wollny]
  * Add patch to compile against dcmtk-20170228 Closes: #865781

  [Sebastien Jodogne]
  * Update standards version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 29 Jun 2017 14:05:31 +0200

orthanc-wsi (0.4+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Updated reference paper in d/upstream/metadata.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 01 Mar 2017 13:01:05 +0100

orthanc-wsi (0.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #842168)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 27 Oct 2016 14:39:21 +0200
