=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
export VIEWER_TARGET := libOrthancWSI.so

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

%:
	dh $@ --parallel

CMAKE_APPLICATIONS_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_BUILD_TYPE=""   # The build type must be left empty, see #711515

CMAKE_VIEWER_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DUSE_SYSTEM_OPENLAYERS=ON \
	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.min.css \
	-DOPENLAYERS_JS=$(CURDIR)/BuildViewer/ol.min.js \
	-DCMAKE_BUILD_TYPE=""   # The build type must be left empty, see #711515

override_dh_auto_configure:
	# Configure the command-line tools
	mkdir BuildApplications
	dh_auto_configure --builddirectory=BuildApplications \
			  --sourcedirectory=Applications \
			  -- $(CMAKE_APPLICATIONS_EXTRA_FLAGS)

	# Minify the official OpenLayers 3.19.0 distribution (Debian
	# packages only contains OpenLayers 2 for the time being,
	# which is incompatible with OpenLayers 3)
	mkdir -p BuildViewer
	yui-compressor debian/JS/openlayers-3.19.0/ol-debug.js > BuildViewer/ol.min.js
	yui-compressor debian/JS/openlayers-3.19.0/ol.css > BuildViewer/ol.min.css

	# Configure the Web viewer plugin
	dh_auto_configure --builddirectory=BuildViewer \
			  --sourcedirectory=ViewerPlugin \
			  -- $(CMAKE_VIEWER_EXTRA_FLAGS)

override_dh_auto_build:
	# Build the command-line tools
	dh_auto_build --builddirectory=BuildApplications \
		      --sourcedirectory=Applications

	# Build the Web viewer plugin
	dh_auto_build --builddirectory=BuildViewer \
		      --sourcedirectory=ViewerPlugin

override_dh_auto_install:
	# Install the command-line tools
	dh_auto_install --builddirectory=BuildApplications

	# Install the plugin
	cp BuildViewer/${VIEWER_TARGET} BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION}
	dh_install BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION} usr/lib

override_dh_link:
	dh_link usr/lib/${VIEWER_TARGET}.${UPSTREAM_VERSION} \
		usr/share/orthanc/plugins/${VIEWER_TARGET}

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

get-orig-source:
	uscan --verbose --force-download --repack --compression xz
