=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,downloadurlmangle=s/\/browse\.php\?path=//g,repack,compression=xz" \
http://www.orthanc-server.com/browse.php?path=/whole-slide-imaging downloads/get\.php\?path=/whole-slide-imaging/OrthancWSI-(\d\S*)\.tar\.gz
